// Filename        : dff_ld.v
// Description     : parameterizable D flip-flop with LD signal

module dff_ld (clk, load, d, y);
   parameter Width = 1;

   input     clk, load;
   input [Width-1:0] d;
   output [Width-1:0] y;

   wire [Width-1:0]   ff_in;

   assign
	 ff_in = load ? d : y;
   
   dff #(Width) dff0(clk, ff_in, y);

endmodule // DFF

